#### Beyond Linux® From Scratch (System V Edition) - Version 12.3

### Chapter 13. Programming

- Prev

  PHP-8.4.4

- Next

  Python-3.11.1

- Up
- Home

# Python-3.13.2

## Introduction to Python 3

The Python 3 package contains the Python development environment. This is useful for object-oriented programming, writing scripts, prototyping large programs or developing entire applications.

### Note

Python 3 was installed in LFS. The only reason to rebuild it here is if optional modules are needed, or to upgrade this package.

This package is known to build and work properly using an LFS 12.3 platform.

### Important

If upgrading to a new Python-3 minor version (for example, from Python-3.11.x to Python-3.12.0), you will need to reinstall any Python3 modules you have installed. You should also reinstall packages that generate Python3 modules including GLib-2.82.5 (with GObject Introspection), libxml2-2.13.6, opencv-4.11.0, FontForge-20230101, gnome-tweaks-46.1, Samba-4.21.4, and Graphviz-12.2.1 (if swig is installed).

Before you upgrade, you can get a list of modules installed with pip3 list. The list may be incomplete as some Python modules are not installed with pip3, for example the `cracklib` module installed by CrackLib-2.10.3. Use ls /usr/lib/python3.`minor`/site-packages for a comprehensive list.

The Python modules from LFS will also have to be reinstalled: flit-core, wheel, setuptools, meson, MarkupSafe, and Jinja2.

### Package Information

- Download (HTTP): https://www.python.org/ftp/python/3.13.2/Python-3.13.2.tar.xz

- Download MD5 sum: 4c2d9202ab4db02c9d0999b14655dfe5

- Download size: 22 MB

- Estimated disk space required: 649 MB (add 65 MB for tests)

- Estimated build time: 2.1 SBU (add 1.1 SBU for tests; both using parallelism=4)

### Additional Optional Download

- Download (HTTP): https://www.python.org/ftp/python/doc/3.13.2/python-3.13.2-docs-html.tar.bz2

- Download MD5 sum: d6aede88f480a018d26b3206f21654ae

### Python 3 Dependencies

#### Recommended

SQLite-3.49.1 (required if building firefox or thunderbird)

#### Optional

BlueZ-5.79, GDB-16.2 (required for some tests), Valgrind-3.24.0, and libmpdec

#### Optional (For Additional Modules)

libnsl-2.0.1, Tk-8.6.16, and Berkeley DB (deprecated)

Editor Notes: https://wiki.linuxfromscratch.org/blfs/wiki/Python3

## Installation of Python 3

Install Python 3 by running the following commands:

    CXX="/usr/bin/g++"               \
    ./configure --prefix=/usr        \
                --enable-shared      \
                --with-system-expat  \
                --enable-optimizations &&
    make

Some tests are known to occasionally hang indefinitely. So to test the results, run the test suite but set a 2-minute time limit for each test case:

    make test TESTOPTS="--timeout 120"

For a relatively slow system you may need to increase the time limit and 1 SBU (measured when building Binutils pass 1 with one CPU core) should be enough. Some tests are flaky, so the test suite will automatically re-run failed tests. If a test failed but then passed when re-run, it should be considered as passed.

Of over 44,000 tests, the following test is known to fail: test_importlib.

Now, as the `root` user:

    make install

If upgrading and the documentation has been downloaded, optionally install it as the `root` user:

    install -v -dm755 /usr/share/doc/python-3.13.2/html

    tar --strip-components=1  \
        --no-same-owner       \
        --no-same-permissions \
        -C /usr/share/doc/python-3.13.2/html \
        -xvf ../python-3.13.2-docs-html.tar.bz2

## Command Explanations

CXX="/usr/bin/g++" ./configure ...: Avoid an annoying message during configuration.

`--with-system-expat`: This switch enables linking against the system version of Expat.

`--enable-optimizations`: This switch enables stable, but expensive, optimizations.

`--with-lto`: This optional switch enables thick Link Time Optimization. Unusually, it creates a much larger `/usr/lib/python3.13/config-3.13-<arch>-linux-gnu/libpython3.13.a` with a small increase in the time to compile Python. Run-time results do not appear to show any benefit from doing this.

## Configuring Python 3

In order for python3 to find the installed documentation, create the following version independent symlink:

    ln -svfn python-3.13.2 /usr/share/doc/python-3

and add the following environment variable to the individual user's or system's profile:

    export PYTHONDOCS=/usr/share/doc/python-3/html

## Contents

Installed Programs: 2to3 (symlink) and 2to3-3.13, idle3 (symlink) and idle3.13, pip3 and pip3.13, pydoc3 (symlink) and pydoc3.13, python3 (symlink) and python3.13, and python3-config (symlink) and python3.13-config
Installed Libraries: libpython3.13.so and libpython3.so
Installed Directories: /usr/include/python3.13, /usr/lib/python3.13, and /usr/share/doc/python-3.13.2

### Short Descriptions

idle3 | is a wrapper script that opens a Python aware GUI editor. For this script to run, you must have installed Tk before Python so that the Tkinter Python module is built
pydoc3 | is the Python documentation tool
python3 | is an interpreted, interactive, object-oriented programming language
python3.13 | is a version-specific name for the python program

- Prev

  PHP-8.4.4

- Next

  Python-3.11.1

- Up
- Home